;DAM Editor by GEM

#include <DGE.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <Array.au3>

Global $first = True
Global $size = 500
Dim $map[1][1][1]
Dim $texturen[1][3] = [[0, 0, 0]]
Dim $info[7] = [0, 0, 0, 0, 50, 0, 0]
Dim $collision[1]
$info[2] = $size / $info[4]
$info[3] = $size / $info[4]
Global $title = "DAM Editor"
Global $gui = _DGE_CreateWindow($title, $size, $size, "close")
Local $pos = WinGetPos($gui[0])
$gui2 = GUICreate("Toolbar", 166, 388, $pos[0] + $pos[2], $pos[1], -1, -1, $gui[0])
GUICtrlCreateButton("Save Map", 10, 70, 145, 25)
GUICtrlSetOnEvent(-1, "save")
GUICtrlCreateButton("New Map", 10, 10, 145, 25)
GUICtrlSetOnEvent(-1, "new")
GUICtrlCreateButton("Open Map", 10, 40, 145, 25)
GUICtrlSetOnEvent(-1, "open")
GUICtrlCreateLabel("Texture LM:", 10, 100, 61, 17)
GUICtrlCreateLabel("Texture RM:", 10, 150, 63, 17)
$texturlist1 = GUICtrlCreateCombo("", 10, 120, 145, 25)
$texturlist2 = GUICtrlCreateCombo("", 10, 170, 145, 25)
GUICtrlCreateButton("Load Texture", 10, 200, 145, 25)
GUICtrlSetOnEvent(-1, "loadtexture")
GUICtrlCreateButton("Replace Texture", 10, 230, 145, 25)
GUICtrlSetOnEvent(-1, "replacetexture")
GUICtrlCreateButton("Up", 60, 280, 45, 25)
GUICtrlSetOnEvent(-1, "up")
GUICtrlCreateButton("Left", 20, 310, 45, 25)
GUICtrlSetOnEvent(-1, "left")
GUICtrlCreateButton("Right", 100, 310, 45, 25)
GUICtrlSetOnEvent(-1, "right")
GUICtrlCreateButton("Down", 60, 340, 45, 25)
GUICtrlSetOnEvent(-1, "down")
GUICtrlCreateGroup("", 10, 260, 145, 115)
GUISetState(@SW_SHOW, $gui2)
emptymap(100, 100)

While True
	If _IsPressed(74, $user32dll) Then new()
	If _IsPressed(75, $user32dll) Then open()
	If _IsPressed(76, $user32dll) Then save()
	If _IsPressed(27, $user32dll) Then right()
	If _IsPressed(25, $user32dll) Then left()
	If _IsPressed(28, $user32dll) Then down()
	If _IsPressed(26, $user32dll) Then up()
	If _IsPressed(77, $user32dll) Then clear()
	If _IsPressed("6B", $user32dll) Then zoomin()
	If _IsPressed("6d", $user32dll) Then zoomout()
	If _IsPressed(78, $user32dll) Then texturedit()
	If WinActive($gui[0]) Then
		If _IsPressed(1, $user32dll) Or _IsPressed(2, $user32dll) Then
			Local $pos = GUIGetCursorInfo($gui[0])
			If $pos <> 0 And $pos[0] >= 0 And $pos[1] >= 0 And $pos[0] < $size And $pos[1] < $size Then
				Local $posx = $info[0] + Int($pos[0] / $info[4])
				Local $posy = $info[1] + Int($pos[1] / $info[4])

				If _IsPressed(1, $user32dll) Then
					If _IsPressed(11, $user32dll) Then
						$map[$posx][$posy][0] = Chr(1)
						$map[$posx][$posy][1] = Chr(1)
					Else
						Local $read = GUICtrlRead($texturlist1)
						For $i = 0 To UBound($texturen) - 1
							If $read = $texturen[$i][2] Then
								$map[$posx][$posy][0] = $texturen[$i][0]
								$map[$posx][$posy][1] = $texturen[$i][1]
								ExitLoop
							EndIf
						Next
					EndIf
				EndIf
				If _IsPressed(2, $user32dll) Then
					Local $read = GUICtrlRead($texturlist2)
					For $i = 0 To UBound($texturen) - 1
						If $read = $texturen[$i][2] Then
							$map[$posx][$posy][0] = $texturen[$i][0]
							$map[$posx][$posy][1] = $texturen[$i][1]
							ExitLoop
						EndIf
					Next
				EndIf
			EndIf
		EndIf
	EndIf
	_DGE_ClearWindow($gui)
	_DGE_DrawDAM($gui[3], $map, $texturen, $info)
	_DGE_UpdateWindow($gui)
WEnd

Func clear()
	Local $read = GUICtrlRead($texturlist1)
	For $i = 0 To UBound($texturen) - 1
		If $read = $texturen[$i][2] Then
			For $a = 0 To UBound($map) - 1
				For $b = 0 To UBound($map, 2) - 1
					If $map[$a][$b][0] = Chr(1) Then
						$map[$a][$b][0] = $texturen[$i][0]
						$map[$a][$b][1] = $texturen[$i][1]
					EndIf
				Next
			Next
			ExitLoop
		EndIf
	Next
EndFunc   ;==>clear

Func texturedit()
	Local $read = GUICtrlRead($texturlist1)
	For $a = 0 To UBound($texturen) - 1
		If $read = $texturen[$a][2] Then
			Local $lcol = $texturen[$a][0]
			For $i = 0 To UBound($collision) - 1
				If $lcol = $collision[$i] Then
					Local $msgbox = MsgBox(36, $title, "Mchten Sie die Texture aus der Kollisionsliste lschen?")
					If $msgbox = 6 Then
						If UBound($collision) = 1 Then
							$collision[0] = ""
						Else
							_ArrayDelete($collision, $i)
						EndIf
					EndIf
					Return 0
				EndIf
			Next
			Local $msgbox = MsgBox(36, $title, "Mchten Sie die Texture zu der Kollisionsliste hinzufgen?")
			If $msgbox = 6 Then
				If $collision[0] = "" Then
					$collision[0] = $lcol
				Else
					ReDim $collision[UBound($collision) + 1]
					$collision[UBound($collision) - 1] = $lcol
				EndIf
			EndIf
			Return 0
		EndIf
	Next
EndFunc   ;==>texturedit

Func zoomin()
	If $info[4] <> 100 Then
		$info[4] += 1
		$info[2] = Int($size / $info[4]) + 1
		$info[3] = Int($size / $info[4]) + 1
	EndIf
EndFunc   ;==>zoomin

Func zoomout()
	If $info[4] <> 4 Then
		$info[4] -= 1
		$info[2] = Int($size / $info[4]) + 1
		$info[3] = Int($size / $info[4]) + 1
	EndIf
EndFunc   ;==>zoomout


Func replacetexture()
	Local $path = FileOpenDialog("Open Texture", @ScriptDir, "JPG (*.jpg)|PNG (*.png)|BMP (*.bmp)|GIF (*.gif)")
	If Not @error Then
		_ArrayDisplay($texturen)
		Local $id = InputBox($title, "Bitte geben Sie die ID der Texture an")
		If $id < UBound($texturen) Then
			_GDIPlus_ImageDispose($texturen[$id][1])
			$texturen[$id][1] = _GDIPlus_ImageLoadFromFile($path)
			$texturen[$id][2] = StringRight($path, StringLen($path) - StringInStr($path, "\", 0, -1))
			re()
		EndIf
	EndIf
EndFunc   ;==>replacetexture

Func loadtexture()
	If $first Then
		MsgBox(48, $title, "Sie knnen auch mehrer Texturen auswhlen und hinzufgen!")
		$first = False
	EndIf
	Local $files = FileOpenDialog("Open Textures", @ScriptDir, "JPG (*.jpg)|PNG (*.png)|BMP (*.bmp)|GIF (*.gif)", 4)
	If Not @error Then
		Local $split = StringSplit($files, "|", 2)
		Local $bound = UBound($texturen)
		If $texturen[0][2] = "" Then $bound = 0
		If UBound($split) = 1 Then
			ReDim $texturen[$bound + 1][3]
			$texturen[$bound][0] = Chr($bound + 2)
			$texturen[$bound][1] = _GDIPlus_ImageLoadFromFile($split[0])
			$texturen[$bound][2] = StringRight($split[0], StringLen($split[0]) - StringInStr($split[0], "\", 0, -1))
		Else
			ReDim $texturen[$bound + UBound($split) - 1][3]
			$start = $bound - 1
			For $i = 1 To UBound($split) - 1
				$texturen[$start + $i][0] = Chr($start + $i + 2)
				$texturen[$start + $i][1] = _GDIPlus_ImageLoadFromFile($split[0] & "\" & $split[$i])
				$texturen[$start + $i][2] = $split[$i]
			Next
		EndIf
		re()
	EndIf
EndFunc   ;==>loadtexture

Func right()
	If $info[0] < UBound($map) - $info[2] - 1 Then $info[0] += 1
EndFunc   ;==>right

Func left()
	If $info[0] <> 0 Then $info[0] -= 1
EndFunc   ;==>left

Func down()
	If $info[1] < UBound($map, 2) - $info[3] - 1 Then $info[1] += 1
EndFunc   ;==>down

Func up()
	If $info[1] <> 0 Then $info[1] -= 1
EndFunc   ;==>up

Func close()
	GUIDelete($gui2)
	_DGE_UnloadDAM($map, $texturen, $collision)
	_DGE_DisposeWindow($gui)
	Exit
EndFunc   ;==>close

Func save()
	Local $path = FileSaveDialog("Save DAM", "", "DAM (*.dam)")
	If Not @error Then
		Local $bound = UBound($texturen)
		Local $data = $bound & ";"
		For $i = 0 To $bound - 1
			$data &= $texturen[$i][0] & "=" & $texturen[$i][2]
			If $i = $bound - 1 Then
				$data &= "|"
				ExitLoop
			Else
				$data &= ";"
			EndIf
		Next
		$data &= UBound($map) & ";" & UBound($map, 2) & ";"
		For $a = 0 To UBound($map) - 1
			For $b = 0 To UBound($map, 2) - 1
				$data &= $map[$a][$b][0]
			Next
		Next
		If $collision[0] = "" Then
			$data &= "|"
		Else
			$data &= "|" & UBound($collision) & ";"
			For $i = 0 To UBound($collision) - 1
				$data &= $collision[$i]
				If $i <> UBound($collision) - 1 Then $data &= ";"
			Next
		EndIf
		If FileExists($path) Then
			Local $file = FileOpen($path, 2)
			FileWrite($file, $data)
			FileClose($file)
		Else
			If StringRight($path, 4) <> ".dam" Then $path &= ".dam"
			FileWrite($path, $data)
		EndIf
	EndIf
EndFunc   ;==>save

Func new()
	Local $msg = MsgBox(4, $title, "Mchten Sie wirklich eine neue Karte erstellen?")
	If $msg = 6 Then
		Local $width = InputBox($title, "Bitte geben Sie die Breite der Karte an")
		Local $height = InputBox($title, "Bitte geben Sie die Hhe der Karte an")
		If Not IsNumber(Int($width)) Or Not IsNumber(Int($height)) Then Return False
		null()
		emptymap($width, $height)
		re()
	EndIf
EndFunc   ;==>new

Func emptymap($width, $height)
	ReDim $map[$width][$height][2]
	For $a = 0 To UBound($map) - 1
		For $b = 0 To UBound($map, 2) - 1
			$map[$a][$b][0] = Chr(1)
			$map[$a][$b][1] = 0
		Next
	Next
EndFunc   ;==>emptymap

Func open()
	Local $path = FileOpenDialog("Open DAM", "", "DMA (*.dam)")
	If Not @error Then
		null()
		If _DGE_LoadDAM($path, $map, $texturen, $collision) < 0 Then close()
		re()
	EndIf
EndFunc   ;==>open

Func null()
	_DGE_UnloadDAM($map, $texturen, $collision)
	$info[0] = 0
	$info[1] = 0
EndFunc   ;==>null

Func re()
	GUICtrlSetData($texturlist1, "", "")
	GUICtrlSetData($texturlist2, "", "")
	Local $text = ""
	For $i = 0 To UBound($texturen) - 1
		$text &= $texturen[$i][2] & "|"
	Next
	$text = StringLeft($text, StringLen($text) - 1)
	GUICtrlSetData($texturlist1, $text, $texturen[0][2])
	GUICtrlSetData($texturlist2, $text, $texturen[0][2])
EndFunc   ;==>re
