#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=Symbol.ico
#AutoIt3Wrapper_Res_requestedExecutionLevel=asInvoker
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
;Shot by GEM

#include <DGE modified for Shot.au3>
#include <Array.au3>
#include <GUIConstants.au3>

Global $walktimer = TimerInit()
Global $walktime = 100
Global $defaultweapon = 0
Global $defaultlife = 100
Global $defaultspeed = 4
Global $running = False
Global $path = @ScriptDir & "\level2.dam"
Dim $weapon[7][6] = [[5, 6, 10, 250, 0, "easy pistole"], _
		[40, 10, 5, 2000, _GDIPlus_ImageLoadFromFile("weapon2.png"), "shotgun"], _
		[10, 15, 10, 100, _GDIPlus_ImageLoadFromFile("weapon4.png"), "uzi"], _
		[15, 20, 7, 150, _GDIPlus_ImageLoadFromFile("weapon5.png"), "ak"], _
		[10, 25, 7, 500, _GDIPlus_ImageLoadFromFile("weapon1.png"), "pistole"], _
		[110, 5, 30, 4000, _GDIPlus_ImageLoadFromFile("weapon6.png"), "rocket launcher"], _
		[90, 25, 5, 5000, _GDIPlus_ImageLoadFromFile("weapon3.png"), "sniper"]]
;0 damage
;1 speed
;2 size
;3 repetition time
;4 image
;5 name
Opt("GUIOnEventMode", 1)
Global $hwnd = GUICreate("Shot Launcher", 234, 217)
GUISetOnEvent(-3, "closelauncher", $hwnd)
GUISetFont(12, 400, 0, "Arial")
Global $inputlife = GUICtrlCreateInput($defaultlife, 100, 139, 121, 26)
GUICtrlCreateLabel("speed:", 10, 111, 55, 22)
GUICtrlCreateLabel("life:", 10, 141, 34, 22)
GUICtrlCreateButton("Start", 10, 180, 215, 25)
GUICtrlSetOnEvent(-1, "start")
Global $inputmap = GUICtrlCreateInput($path, 10, 40, 211, 26)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlCreateButton("choose map", 10, 10, 215, 25)
GUICtrlSetOnEvent(-1, "choosemap")
GUICtrlCreateLabel("default weapon:", 10, 78, 112, 22)
Global $inputweapon = GUICtrlCreateCombo("", 130, 76, 95, 25)
Local $data = "no|"
For $i = 0 To UBound($weapon) - 1
	$data &= $weapon[$i][5]
	If $i <> UBound($weapon) - 1 Then $data &= "|"
Next
GUICtrlSetData(-1, $data, $weapon[0][5])
Global $inputspeed = GUICtrlCreateCombo("", 100, 107, 125, 25)
GUICtrlSetData(-1, "slowly|standard|quickly", "standard")
GUISetState()
Do
Until $running
Global $title = "Shot"
Global $size = 640
Dim $map[1][1][1]
Dim $texturen[1][3]
Dim $player[2][24] = [ _
		[1, 0, 0, 0, 0, 44, 41, 53, 57, 64, $defaultspeed, 100, "A2", 0, 0, 10, _GDIPlus_BrushCreateSolid(0xff00FF00), 10, 10, 9, 30, _GDIPlus_ImageLoadFromFile("spritep1.png"), 0, False], _
		[0, 0, 0, 0, 0, 27, 25, 28, 26, 64, $defaultspeed, 100, "A3", 0, 0, 10, _GDIPlus_BrushCreateSolid(0xff0000ff), $size - 110, 10, $size - 111, 30, _GDIPlus_ImageLoadFromFile("spritep2.png"), 0, False]]
;0 x
;1 y
;2 xp
;3 yp
;4 direction
;5 key right
;6 key left
;7 key down
;8 key up
;9 size
;10 speed
;11 life
;12 key shot
;13 weapon
;14 timer
;15 won
;16 brush
;17 life box x
;18 life box y
;19 win box x
;20 win box y
;21 images
;22 imagex
;23 freeze
Dim $info[7] = [0, 0, 10, 10, 64, 0, 0]
Dim $collision[1]
Dim $shots[1][7]
;0 xa
;1 ya
;2 direction
;3 speed
;4 size
;5 damage
;6 player
Global $gui = _DGE_CreateWindow($title, $size, $size)
$bg = _GDIPlus_ImageLoadFromFile("earth.jpg")
$brushred = _GDIPlus_BrushCreateSolid(0xffff0000)
$brushwhite = _GDIPlus_BrushCreateSolid(0xffffffff)
loadlevel()

While True
	For $i = 0 To UBound($player) - 1
		If $player[$i][4] <> 0 Then $direction = $player[$i][4]
		If Asc($map[$player[$i][0]][$player[$i][1]][0]) >= 100 Then
			If $player[$i][13] <> Asc($map[$player[$i][0]][$player[$i][1]][0]) - 100 Then
				$player[$i][13] = Asc($map[$player[$i][0]][$player[$i][1]][0]) - 100
				$map[$player[$i][0]][$player[$i][1]][0] = Chr(1)
				$map[$player[$i][0]][$player[$i][1]][1] = Chr(1)
			EndIf
		EndIf
		Local $direction = Random(1, 4, 1)
		Local $pressed = False
		For $z = 5 To 8
			If _IsPressed($player[$i][$z], $user32dll) Then
				$direction = $z - 4
				If $player[$i][23] <> True Then $pressed = True
			EndIf
		Next
		If $pressed = False And _IsPressed($player[$i][12], $user32dll) And $player[$i][2] = 0 And $player[$i][3] = 0 Then
			$player[$i][23] = True
		Else
			$player[$i][23] = False
		EndIf
		If _IsPressed($player[$i][12], $user32dll) And TimerDiff($player[$i][14]) >= $weapon[$player[$i][13]][3] Then
			Local $bound = UBound($shots)
			ReDim $shots[$bound + 1][7]
			$shots[$bound][4] = $weapon[$player[$i][13]][2]
			$shots[$bound][0] = $player[$i][0] * 64 + ((64 - $shots[$bound][4]) / 2)
			$shots[$bound][1] = $player[$i][1] * 64 + ((64 - $shots[$bound][4]) / 2)
			$shots[$bound][2] = $direction
			$shots[$bound][3] = $weapon[$player[$i][13]][1]
			$shots[$bound][5] = $weapon[$player[$i][13]][0]
			$shots[$bound][6] = $i
			$player[$i][14] = TimerInit()
		EndIf
	Next
	_DGE_ClearWindow($gui)
	_GDIPlus_GraphicsDrawImageRect($gui[3], $bg, 0, 0, $size + 10, $size + 10)
	If UBound($shots) > 1 Then
		For $i = 1 To UBound($shots) - 1
			If $i >= UBound($shots) Then ExitLoop
			Switch $shots[$i][2]
				Case 1
					$shots[$i][0] += $shots[$i][3]
				Case 2
					$shots[$i][0] -= $shots[$i][3]
				Case 3
					$shots[$i][1] += $shots[$i][3]
				Case 4
					$shots[$i][1] -= $shots[$i][3]
			EndSwitch
			If $shots[$i][0] < 0 Or $shots[$i][0] > $size Or $shots[$i][1] < 0 Or $shots[$i][1] > $size Then
				_ArrayDelete($shots, $i)
				ContinueLoop
			Else
				Local $posx = Int($shots[$i][0] / 64)
				Local $posy = Int($shots[$i][1] / 64)
				For $a = 0 To UBound($player) - 1
					If $shots[$i][6] <> $a Then
						If $posx = $player[$a][0] And $posy = $player[$a][1] Then
							Local $damage = Random($shots[$i][5] - Random(0, $shots[$i][5], 1), $shots[$i][5] + Random(0, $shots[$i][5], 1), 1)
							If $damage <= 0 Then ExitLoop
							$player[$a][11] -= $damage
							If $player[$a][11] <= 0 Then
								$player[$a][15] -= 1
								If $player[$a][15] = 0 Then
									$MsgBox = MsgBox(68, $title, "Spieler " & ($a + 1) & " hat verloren" & @CRLF & "Mchten Sie nochmal spielen?")
									Select
										Case $MsgBox = 6
											For $i = 0 To UBound($player) - 1
												$player[$i][15] = 10
											Next
										Case $MsgBox = 7
											close()
									EndSelect
								EndIf
								loadlevel()
								ExitLoop 2
							EndIf
							_ArrayDelete($shots, $i)
							ContinueLoop 2
						EndIf
					EndIf
				Next
				If $posx >= 0 And $posy >= 0 And $posx < UBound($map) And $posy < UBound($map, 2) Then
					If $map[$posx][$posy][0] = $collision[0] Then
						If Random(1, 100, 1) > 80 Then
							Local $random = Random(1, UBound($weapon) - 1, 1)
							$map[$posx][$posy][0] = Chr(100 + $random)
							$map[$posx][$posy][1] = $weapon[$random][4]
						Else
							$map[$posx][$posy][0] = Chr(1)
							$map[$posx][$posy][1] = Chr(1)
						EndIf
						_ArrayDelete($shots, $i)
						ContinueLoop
					EndIf
					If $map[$posx][$posy][0] = $collision[1] Then
						_ArrayDelete($shots, $i)
						ContinueLoop
					EndIf
				EndIf
				_GDIPlus_GraphicsFillEllipse($gui[3], $shots[$i][0], $shots[$i][1], $shots[$i][4], $shots[$i][4], $brushred)
			EndIf
		Next
	EndIf
	_DGE_DrawDAM($gui[3], $map, $texturen, $info)
	_DGE_DrawDAP($gui[3], $map, $info, $player)
	_DGE_MoveDAP($player, $map, $collision)
	For $i = 0 To UBound($player) - 1
		_GDIPlus_GraphicsFillRect($gui[3], $player[$i][17] - 1, $player[$i][18] - 1, 102, 22, $brushwhite)
		_GDIPlus_GraphicsFillRect($gui[3], $player[$i][17], $player[$i][18], (100 / $defaultlife) * $player[$i][11], 20, $player[$i][16])
		_GDIPlus_GraphicsFillRect($gui[3], $player[$i][19], $player[$i][20], 20, 20, $brushwhite)
		_GDIPlus_GraphicsDrawString($gui[3], $player[$i][15], $player[$i][19], $player[$i][20])
		_GDIPlus_GraphicsFillRect($gui[3], $player[$i][19] + 60, $player[$i][20], 32, 32, $brushwhite)
		_GDIPlus_GraphicsDrawImageRect($gui[3], $weapon[$player[$i][13]][4], $player[$i][19] + 60, $player[$i][20], 32, 32)
		_GDIPlus_GraphicsFillRect($gui[3], $player[$i][19] + 20, $player[$i][20], 40, 20, $brushwhite)
		Local $procent = Int(TimerDiff($player[$i][14]) / $weapon[$player[$i][13]][3] * 100)
		If $procent > 100 Then $procent = 100
		_GDIPlus_GraphicsDrawString($gui[3], $procent & "%", $player[$i][19] + 20, $player[$i][20])
	Next
	_DGE_UpdateWindow($gui)
WEnd

Func close()
	For $i = 0 To UBound($weapon) - 1
		_GDIPlus_ImageDispose($weapon[$i][4])
	Next
	For $i = 0 To UBound($player) - 1
		_GDIPlus_BrushDispose($player[$i][16])
		_GDIPlus_ImageDispose($player[$i][21])
	Next
	_GDIPlus_ImageDispose($bg)
	_GDIPlus_BrushDispose($brushwhite)
	_GDIPlus_BrushDispose($brushred)
	_DGE_UnloadDAM($map, $texturen, $collision)
	_DGE_DisposeWindow($gui)
	Exit
EndFunc   ;==>close

Func loadlevel()
	Local $x, $y
	_DGE_UnloadDAM($map, $texturen, $collision)
	If _DGE_LoadDAM($path, $map, $texturen, $collision) < 0 Then close()
	Dim $shots[1][8], $random
	For $i = 0 To UBound($player) - 1
		$x = Random(0, 9, 1)
		$y = Random(0, 9, 1)
		$map[$x][$y][0] = Chr(1)
		$map[$x][$y][1] = Chr(1)
		$player[$i][0] = $x
		$player[$i][1] = $y
		$player[$i][2] = 0
		$player[$i][3] = 0
		$player[$i][4] = 0
		$player[$i][11] = $defaultlife
		$player[$i][13] = $defaultweapon
		$player[$i][14] = TimerInit()
		$player[$i][23] = False
	Next
	For $i = 0 To 1
		$x = Random(0, 9, 1)
		$y = Random(0, 9, 1)
		$random = Random(1, UBound($weapon) - 1, 1)
		$map[$x][$y][0] = Chr(1)
		$map[$x][$y][1] = Chr(1)
		$map[$x][$y][0] = Chr(100 + $random)
		$map[$x][$y][1] = $weapon[$random][4]
	Next
EndFunc   ;==>loadlevel

Func closelauncher()
	For $i = 0 To UBound($weapon) - 1
		_GDIPlus_ImageDispose($weapon[$i][4])
	Next
	GUIDelete($hwnd)
	Exit
EndFunc   ;==>closelauncher

Func start()
	Local $read
	$read = GUICtrlRead($inputweapon)
	For $i = 0 To UBound($weapon) - 1
		If $read = $weapon[$i][5] Then
			$defaultweapon = $i
			ExitLoop
		EndIf
	Next
	$read = Int(GUICtrlRead($inputlife))
	If $read > 0 And $read < 9999 Then $defaultlife = $read
	$read = GUICtrlRead($inputspeed)
	Switch $read
		Case "slowly"
			$defaultspeed = 2
		Case "quickly"
			$defaultspeed = 8
	EndSwitch
	GUIDelete($hwnd)
	$running = True
EndFunc   ;==>start

Func choosemap()
	Local $read = FileOpenDialog("Choose map", @ScriptDir, "DAM (*.dam)")
	If Not @error Then
		$path = $read
		GUICtrlSetData($inputmap, $path)
	EndIf
EndFunc   ;==>choosemap
