;DAM Viewer by GEM

#include <DGE.au3>

Global $path = FileOpenDialog("Open DAM", "", "DAM (*.dam)")
If @error Then Exit
Global $size = 500
Dim $map[1][1][1]
Dim $texturen[1][3]
Dim $collision[1]
Dim $info[7] = [0, 0, 0, 0, 32, 0, 0]
zoomin()
Global $title = "DAM Viewer"
Global $gui = _DGE_CreateWindow($title, $size, $size, "close")
If _DGE_LoadDAM($path, $map, $texturen, $collision) < 0 Then close()

While True
	If _IsPressed(27, $user32dll) Then right()
	If _IsPressed(25, $user32dll) Then left()
	If _IsPressed(28, $user32dll) Then down()
	If _IsPressed(26, $user32dll) Then up()
	If _IsPressed("6B", $user32dll) Then zoomin()
	If _IsPressed("6d", $user32dll) Then zoomout()
	_DGE_ClearWindow($gui)
	_DGE_DrawDAM($gui[3], $map, $texturen, $info)
	_DGE_UpdateWindow($gui)
	Sleep(10)
WEnd

Func close()
	_DGE_UnloadDAM($map, $texturen, $collision)
	_DGE_DisposeWindow($gui)
	Exit
EndFunc   ;==>close

Func right()
	If $info[0] < UBound($map) - $info[2] - 1 Then $info[0] += 1
EndFunc   ;==>right

Func left()
	If $info[0] <> 0 Then $info[0] -= 1
EndFunc   ;==>left

Func down()
	If $info[1] < UBound($map, 2) - $info[3] - 1 Then $info[1] += 1
EndFunc   ;==>down

Func up()
	If $info[1] <> 0 Then $info[1] -= 1
EndFunc   ;==>up

Func zoomin()
	If $info[4] <> 100 Then
		$info[4] += 1
		$info[2] = Int($size / $info[4]) + 1
		$info[3] = Int($size / $info[4]) + 1
	EndIf
EndFunc   ;==>zoomin

Func zoomout()
	If $info[4] <> 4 Then
		$info[4] -= 1
		$info[2] = Int($size / $info[4]) + 1
		$info[3] = Int($size / $info[4]) + 1
	EndIf
EndFunc   ;==>zoomout
